<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css" 
            integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" 
             crossorigin="anonymous">
   <script src="https://cdn.jsdelivr.net/npm/vue/dist/vue.js"></script>
   <script src="https://unpkg.com/vuex@3.1.1/dist/vuex.js"></script>
   <title>Document</title>
</head>
<body>
    <div id="app" class="container">
        <titulo></titulo>
    </div>
    <script> 
        Vue.component('titulo',{
            template://html
            `
            <div>
                <h1>numero {{ numero }}</h1>
                <hijo></hijo>
            </div>
            `,
            //solo se agregra una computar para optimisar store y el mapeo
            computed:{
                ...Vuex.mapState(['numero'])
            }
        });
        Vue.component('hijo',{
            template://html
            `
                <div>
                    <button @click="aumentar">+</button>
                    <button @click="disminuir(2)">-</button>
                    <button @click="obtenerCursos">obtenerCursos</button>
                    <h1>numero{{numero}}</h1>
                    <ul v-for="item of cursos">
                        <li>{{item.nombre}}</li>
                    </ul>
                </div>
            `,
            computed:{
                ...Vuex.mapState(['numero','cursos'])
            },
            methods:{
                ...Vuex.mapMutations(['aumentar','disminuir']),
                ...Vuex.mapActions(['obtenerCursos'])    
            }    
        });
        const store=new Vuex.Store({
            state:{
                numero:10,
                cursos:[]
            },
            mutations:{ 
                aumentar(state){
                    state.numero++
                } ,
                disminuir(state,n){
                    state.numero-=n
                },
                llenarCursos(state,cursosAccion){
                    state.cursos=cursosAccion
                }
           },
           actions:{
               obtenerCursos:async function({commit}){
                   const data=await fetch('cursos.json');
                   const cursos=await data.json();
                   commit('llenarCursos',cursos) 
               }
           }
        });
        
        app=new Vue({
            el: '#app',
            store:store
        });
    </script>    
</body>
</html>